#include "stm32f10x_conf.h"
#include "stm32f10x.h"
#include "ps2.h"
#define MAX_PS2 45
extern unsigned char ps2_buf[MAX_PS2]; //条码缓冲区
extern int ps2_ready; //一次扫描结束标志，扫描到了一个条码
extern int ps2_count;
struct {
	char scan_code;
	char key_code;
} KEY_TAB[11]={ 
	{0x45,'0'},
	{0x16,'1'},
	{0x1e,'2'},
	{0x26,'3'},
	{0x25,'4'},
	{0x2e,'5'},
	{0x36,'6'},
	{0x3d,'7'},
	{0x3e,'8'},
	{0x46,'9'},
	{0x5a,'\0'}
};
void ps2_init(void){
	/* Configure  as input */

	GPIO_InitTypeDef GPIO_InitStructure;
	RCC_APB2PeriphClockCmd(  RCC_APB2Periph_GPIOA, ENABLE  );
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6 |GPIO_Pin_7 ; 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;  //GPIO_Mode_IN_FLOATING;//GPIO_Mode_IPU;
	//硬件没有设计外部上拉，所以设置为内部上拉；
	GPIO_Init(GPIOA, &GPIO_InitStructure);
}
void EXTI9_5_IRQHandler()
{

	unsigned char temp=0;
	int bits_count;

	for (bits_count=0;bits_count<11;bits_count++){
		while(0x00 != GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_7)); //等待时钟变低---时钟低有效 	
		switch (bits_count){
			case 0:
			case 9:   
			case 10:break; //起始位，停止位，校验位，不理会。
			default:{
						temp>>=1;
						if(0x01==GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_6))
							temp|=0x80;	

					}break;
		}		
		while(0x00 == GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_7)); //等待时钟变高--- 
	}
	ps2_buf[ps2_count++]=temp;   //送接收到的一个字节入条码缓冲区
	if(0x5a==temp)
		ps2_ready=1;             //告诉主程序ps2扫描到一个完整的条码输入
	//	EXTI->PR=1<<0; //清除LINE7上的中断标志位
	if(EXTI_GetITStatus(EXTI_Line7)!= RESET)
	{
		EXTI_ClearITPendingBit(EXTI_Line7);
	} 
}
/*
 *解析ps2 扫描码为键码
 *
 *
 */
void ps2_decode(unsigned char *ps2_scan,unsigned *ps2_key)
{
	int i,j,k;
	i=j=k=0;
	while(i<ps2_count){
		if(ps2_scan[i]==0xf0) i+=2;
		else {
			for(k=0;k<11;k++){
				if (ps2_scan[i] == KEY_TAB[k].scan_code){
					ps2_key[j++] = KEY_TAB[k].key_code;
					break;
				}
			}
		}
		i+=1;
	}
}
